You can customize the font style using code such as the following:
You can customize the font by splitted font properties using code such as the following:
You can also set text decorations, such as underline, doubleUnderline, lineThrough, and overline
You can set the font alignment like this:
You can set the font color and cell background color like this:
You can set the font format, such as wordwrap, indent, shrinkToFit, etc.
function setSettings(spread) {
let sheet = spread.getActiveSheet();
let activeCell = sheet.getCell(sheet.getActiveRowIndex(), sheet.getActiveColumnIndex());
document.getElementById('font').value = activeCell.font();
document.getElementById('fontStyle').value = fontStyleOrFontWeightSpreadValueToCssValue(activeCell.fontStyle());
document.getElementById('fontWeight').value = fontStyleOrFontWeightSpreadValueToCssValue(activeCell.fontWeight());
let fontSize = activeCell.fontSize();
if (fontSize) {
let fontSizeDigit = parseFloat(fontSize);
let fontSizeUnit = fontSize.substring(('' + fontSizeDigit).length);
document.getElementById('fontSize').value = fontSizeDigit;
document.getElementById('fontSizeUnit').value = fontSizeUnit;
} else {
document.getElementById('fontSize').value = '';
document.getElementById('fontSizeUnit').value = 'px';
}
document.getElementById('fontFamily').value = activeCell.fontFamily() || '';
}
function fontStyleOrFontWeightCssValueToSpreadValue(value) {
// transfer css font style/weight to spread font style/weight
if (value === '') {
return undefined;
} else if (value === 'normal') {
return null;
} else {
return value;
}
}
function fontStyleOrFontWeightSpreadValueToCssValue(value) {
// transfer spread font style/weight to css font style/weight
if (value === undefined) {
return '';
} else if (value === null) {
return 'normal';
} else {
return value;
}
}
function setFontToSelectedRanges(spread, setFunc) {
let activeSheet = spread.getActiveSheet();
let selections = activeSheet.getSelections();
if (!selections) {
return;
}
activeSheet.suspendPaint();
for (let i = 0; i < selections.length; i++) {
let selection = selections[i];
if (!selection) {
return;
}
for (let r = 0; r < selection.rowCount; r++) {
for (let c = 0; c < selection.colCount; c++) {
let cell = activeSheet.getCell(r + selection.row, c + selection.col);
setFunc(cell);
}
}
}
activeSheet.resumePaint();
}
function setFontBySplittedFont(spread) {
let fontStyle = document.getElementById('fontStyle').value,
fontWeight = document.getElementById('fontWeight').value,
fontFamily = document.getElementById('fontFamily').value,
fontSizeDigit = document.getElementById('fontSize').value,
fontSizeUnit = document.getElementById('fontSizeUnit').value, fontSize;
if (fontSizeDigit) {
fontSize = fontSizeDigit + (fontSizeUnit ? fontSizeUnit : 'px');
}
setFontToSelectedRanges(spread, (cell) => {
cell.fontStyle(fontStyleOrFontWeightCssValueToSpreadValue(fontStyle));
cell.fontWeight(fontStyleOrFontWeightCssValueToSpreadValue(fontWeight));
cell.fontSize(fontSize);
cell.fontFamily(fontFamily);
});
setSettings(spread);
}
function setFontByFont(spread) {
let font = document.getElementById('font').value;
setFontToSelectedRanges(spread, (cell) => {
cell.font(font);
});
setSettings(spread);
}
function setStyles(sheet) {
sheet.suspendPaint();
//Font
sheet.getCell(2, 0).font('italic normal 12px Mangal');
sheet.getCell(4, 0).font('normal bold 15px Arial Black');
sheet.getCell(6, 0).font('normal normal 18px Georgia');
//FontFamily
sheet.getCell(2, 1).fontFamily('Mangal');
sheet.getCell(4, 1).fontFamily('Arial Black');
sheet.getCell(6, 1).fontFamily('Georgia');
//FontSize
sheet.getCell(2, 2).fontSize('12px');
sheet.getCell(4, 2).fontSize('20px');
sheet.getCell(6, 2).fontSize('28px');
//Bold
sheet.getCell(2, 3).fontWeight('bold');
sheet.getCell(4, 3).fontWeight('normal');
//Italic
sheet.getCell(2, 4).fontStyle('italic');
sheet.getCell(4, 4).fontStyle('normal');
//Line
sheet.getCell(2, 5).textDecoration(GC.Spread.Sheets.TextDecorationType.underline);
sheet.getCell(4, 5).textDecoration(GC.Spread.Sheets.TextDecorationType.doubleUnderline);
sheet.getCell(6, 5).textDecoration(GC.Spread.Sheets.TextDecorationType.lineThrough);
sheet.getCell(8, 5).textDecoration(GC.Spread.Sheets.TextDecorationType.overline);
//Align
sheet.getCell(2, 6).vAlign(GC.Spread.Sheets.VerticalAlign.top).hAlign(GC.Spread.Sheets.HorizontalAlign.left);
sheet.getCell(4, 6).vAlign(GC.Spread.Sheets.VerticalAlign.center).hAlign(GC.Spread.Sheets.HorizontalAlign.center);
sheet.getCell(6, 6).vAlign(GC.Spread.Sheets.VerticalAlign.bottom).hAlign(GC.Spread.Sheets.HorizontalAlign.right);
//Forecolor
sheet.getCell(2, 7).foreColor('#F7A711');
sheet.getCell(4, 7).foreColor('#82BC00');
sheet.getCell(6, 7).foreColor('#C3C3C3');
//backgroundColor
sheet.getCell(2, 8).backColor('#F7A711');
sheet.getCell(4, 8).backColor('#82BC00');
sheet.getCell(6, 8).backColor('#C3C3C3');
//WordWrap
sheet.getCell(2, 9).wordWrap(true);
sheet.getCell(3, 9).wordWrap(true);
//Indent
sheet.getCell(2, 10).textIndent(1);
sheet.getCell(4, 10).textIndent(3);
sheet.getCell(6, 10).textIndent(-2);
//ShrinkToFit
sheet.getCell(2, 11).shrinkToFit(true).vAlign(GC.Spread.Sheets.VerticalAlign.center);
sheet.getCell(4, 11).shrinkToFit(true).vAlign(GC.Spread.Sheets.VerticalAlign.bottom);
sheet.resumePaint();
}
window.onload = function () {
var spread = new GC.Spread.Sheets.Workbook(document.getElementById('ss'));
var sheet = spread.getActiveSheet();
sheet.fromJSON(jsonData);
setStyles(sheet);
setSettings(spread);
bindEvents(spread);
};
function bindEvents(spread) {
document.getElementById("set-splitted-font").addEventListener('click', function () {
setFontBySplittedFont(spread);
});
document.getElementById("set-font").addEventListener('click', function () {
setFontByFont(spread);
});
spread.bind(GC.Spread.Sheets.Events.SelectionChanged, function () {
setSettings(spread);
});
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script>
<script src="data.js" type="text/javascript"></script>
<script src="app.js" type="text/javascript"></script>
<link rel="stylesheet" type="text/css" href="styles.css">
</head>
<body>
<div class="sample-tutorial">
<div id="ss" class="sample-spreadsheets"></div>
<div class="options-container">
<p>Select a cell, Set font for it.</p>
<div class="settings-row">
<label for="fontStyle">Font Style:</label>
<input id="fontStyle" type="text">
</div>
<div class="settings-row">
<label for="fontWeight">Font Weight:</label>
<input id="fontWeight" type="text">
</div>
<div class="settings-row">
<label for="fontSize">Font Size:</label>
<input id="fontSize" type="number" min="0">
<select id="fontSizeUnit">
<option value="px">px</option>
<option value="pt">pt</option>
</select>
</div>
<div class="settings-row">
<label for="fontFamily">Font Family:</label>
<input id="fontFamily" type="text">
</div>
<div class="settings-row">
<button id="set-splitted-font" class="settings-btn">Set Font Using Font Properties</button>
</div>
<br/>
<div class="settings-row">
<label for="font">Font:</label>
<input type="text" id="font">
</div>
<div class="settings-row">
<button id="set-font" class="settings-btn">Set Font By Font</button>
</div>
</div>
</div>
</body>
</html>
var jsonData = {
"name": "Sheet1",
"isSelected": true,
"activeRow": 10,
"activeCol": 5,
"visible": 1,
"theme": "Office",
"data": {
"dataTable": {
"1": {
"0": {
"value": "Font",
"style": {
"backColor": "#82bc00",
"foreColor": "white"
}
},
"1": {
"value": "FontFamily",
"style": {
"backColor": "#82bc00",
"foreColor": "white"
}
},
"2": {
"value": "FontSize",
"style": {
"backColor": "#82bc00",
"foreColor": "white"
}
},
"3": {
"value": "Bold",
"style": {
"backColor": "#82bc00",
"foreColor": "white"
}
},
"4": {
"value": "Italic",
"style": {
"backColor": "#82bc00",
"foreColor": "white"
}
},
"5": {
"value": "TextDecoration",
"style": {
"backColor": "#82bc00",
"foreColor": "white"
}
},
"6": {
"value": "Align",
"style": {
"backColor": "#82bc00",
"foreColor": "white"
}
},
"7": {
"value": "ForeColor",
"style": {
"backColor": "#82bc00",
"foreColor": "white"
}
},
"8": {
"value": "BackgroundColor",
"style": {
"backColor": "#82bc00",
"foreColor": "white"
}
},
"9": {
"value": "WordWrap",
"style": {
"backColor": "#82bc00",
"foreColor": "white"
}
},
"10": {
"value": "Indent",
"style": {
"backColor": "#82bc00",
"foreColor": "white"
}
},
"11": {
"value": "ShrinkToFit",
"style": {
"backColor": "#82bc00",
"foreColor": "white"
}
}
},
"2": {
"0": {
"value": "Font"
},
"1": {
"value": "FontFamily"
},
"2": {
"value": "FontSize"
},
"3": {
"value": "Bold"
},
"4": {
"value": "Italic"
},
"5": {
"value": "UnderLine"
},
"6": {
"value": "Align"
},
"7": {
"value": "Forecolor"
},
"8": {
"value": "BackColor"
},
"9": {
"value": "Word-Wrap Word-Wrap Word-Wrap"
},
"10": {
"value": "Indent"
},
"11": {
"value": "This is a long text"
}
},
"3": {
"9": {
"value": "Word\r\nWrap"
}
},
"4": {
"0": {
"value": "Font"
},
"1": {
"value": "FontFamily"
},
"2": {
"value": "FontSize"
},
"3": {
"value": "Bold"
},
"4": {
"value": "Italic"
},
"5": {
"value": "DbUnderLine"
},
"6": {
"value": "Align"
},
"7": {
"value": "Forecolor"
},
"8": {
"value": "BackColor"
},
"10": {
"value": "Indent"
},
"11": {
"value": "ShrinkToFit"
}
},
"6": {
"0": {
"value": "Font"
},
"1": {
"value": "FontFamily"
},
"2": {
"value": "FontSize"
},
"5": {
"value": "lineThrough"
},
"6": {
"value": "Align"
},
"7": {
"value": "Forecolor"
},
"8": {
"value": "BackColor"
},
"10": {
"value": "Indent"
}
},
"8": {
"5": {
"value": "overline"
}
}
},
"defaultDataNode": {
"style": {
"themeFont": "Body"
}
}
},
"rowHeaderData": {
"defaultDataNode": {
"style": {
"themeFont": "Body"
}
}
},
"colHeaderData": {
"defaultDataNode": {
"style": {
"themeFont": "Body"
}
}
},
"rows": [
null,
null,
{
"size": 50
},
{
"size": 50
},
{
"size": 50
},
null,
{
"size": 50
}
],
"columns": [
{
"size": 120
},
{
"size": 120
},
{
"size": 120
},
null,
null,
{
"size": 100
},
{
"size": 100
},
null,
{
"size": 120
},
{
"size": 80
},
{
"size": 80
},
{
"size": 100
}
],
"defaultData": {},
"leftCellIndex": 0,
"topCellIndex": 0,
"selections": {
"0": {
"row": 10,
"col": 5,
"rowCount": 1,
"colCount": 1
},
"length": 1
},
"rowOutlines": {
"items": []
},
"columnOutlines": {
"items": []
},
"cellStates": {},
"states": {},
"outlineColumnOptions": {},
"autoMergeRangeInfos": [],
"shapeCollectionOption": {
"snapMode": 0
},
"printInfo": {
"paperSize": {
"width": 850,
"height": 1100,
"kind": 1
}
}
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
label {
display: inline-block;
width: 80px;
}
.settings-row {
width: 100%;
height: 30px;
font-size: 13px;
}
.settings-btn {
display: inline-block;
width: 220px;
height: 21px;
}
#fontSize {
width: 80px;
}
.settings-row input {
width: 160px;
}

You can customize the font style using code such as the following:
You can customize the font by splitted font properties using code such as the following:
You can also set text decorations, such as underline, doubleUnderline, lineThrough, and overline
You can set the font alignment like this:
You can set the font color and cell background color like this:
You can set the font format, such as wordwrap, indent, shrinkToFit, etc.
import * as React from 'react';
import { createRoot } from 'react-dom/client';
import './styles.css';
import { AppFunc } from './app-func';
// import { App } from './app-class';
// 1. Functional Component sample
createRoot(document.getElementById('app')).render(<AppFunc />);
// 2. Class Component sample
// createRoot(document.getElementById('app')).render(<App />);
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import { SpreadSheets } from '@mescius/spread-sheets-react';
function fontStyleOrFontWeightCssValueToSpreadValue(value) {
// transfer css font style/weight to spread font style/weight
if (value === '') {
return undefined;
} else if (value === 'normal') {
return null;
} else {
return value;
}
}
function fontStyleOrFontWeightSpreadValueToCssValue(value) {
// transfer spread font style/weight to css font style/weight
if (value === undefined) {
return '';
} else if (value === null) {
return 'normal';
} else {
return value;
}
}
function setFontToSelectedRanges(spread, setFunc) {
let activeSheet = spread.getActiveSheet();
let selections = activeSheet.getSelections();
if (!selections) {
return;
}
activeSheet.suspendPaint();
for (let i = 0; i < selections.length; i++) {
let selection = selections[i];
if (!selection) {
return;
}
for (let r = 0; r < selection.rowCount; r++) {
for (let c = 0; c < selection.colCount; c++) {
let cell = activeSheet.getCell(r + selection.row, c + selection.col);
setFunc(cell);
}
}
}
activeSheet.resumePaint();
}
function setStyles(sheet) {
sheet.suspendPaint();
//Font
sheet.getCell(2, 0).font('italic normal 12px Mangal');
sheet.getCell(4, 0).font('normal bold 15px Arial Black');
sheet.getCell(6, 0).font('normal normal 18px Georgia');
//FontFamily
sheet.getCell(2, 1).fontFamily('Mangal');
sheet.getCell(4, 1).fontFamily('Arial Black');
sheet.getCell(6, 1).fontFamily('Georgia');
//FontSize
sheet.getCell(2, 2).fontSize('12px');
sheet.getCell(4, 2).fontSize('20px');
sheet.getCell(6, 2).fontSize('28px');
//Bold
sheet.getCell(2, 3).fontWeight('bold');
sheet.getCell(4, 3).fontWeight('normal');
//Italic
sheet.getCell(2, 4).fontStyle('italic');
sheet.getCell(4, 4).fontStyle('normal');
//Line
sheet.getCell(2, 5).textDecoration(GC.Spread.Sheets.TextDecorationType.underline);
sheet.getCell(4, 5).textDecoration(GC.Spread.Sheets.TextDecorationType.doubleUnderline);
sheet.getCell(6, 5).textDecoration(GC.Spread.Sheets.TextDecorationType.lineThrough);
sheet.getCell(8, 5).textDecoration(GC.Spread.Sheets.TextDecorationType.overline);
//Align
sheet.getCell(2, 6).vAlign(GC.Spread.Sheets.VerticalAlign.top).hAlign(GC.Spread.Sheets.HorizontalAlign.left);
sheet.getCell(4, 6).vAlign(GC.Spread.Sheets.VerticalAlign.center).hAlign(GC.Spread.Sheets.HorizontalAlign.center);
sheet.getCell(6, 6).vAlign(GC.Spread.Sheets.VerticalAlign.bottom).hAlign(GC.Spread.Sheets.HorizontalAlign.right);
//Forecolor
sheet.getCell(2, 7).foreColor('#F7A711');
sheet.getCell(4, 7).foreColor('#82BC00');
sheet.getCell(6, 7).foreColor('#C3C3C3');
//backgroundColor
sheet.getCell(2, 8).backColor('#F7A711');
sheet.getCell(4, 8).backColor('#82BC00');
sheet.getCell(6, 8).backColor('#C3C3C3');
//WordWrap
sheet.getCell(2, 9).wordWrap(true);
sheet.getCell(3, 9).wordWrap(true);
//Indent
sheet.getCell(2, 10).textIndent(1);
sheet.getCell(4, 10).textIndent(3);
sheet.getCell(6, 10).textIndent(-2);
//ShrinkToFit
sheet.getCell(2, 11).shrinkToFit(true).vAlign(GC.Spread.Sheets.VerticalAlign.center);
sheet.getCell(4, 11).shrinkToFit(true).vAlign(GC.Spread.Sheets.VerticalAlign.bottom);
sheet.resumePaint();
}
let spread = null;
export function AppFunc() {
const [fontOption, setFontOption] = React.useState({
fontStyle: 'undefined',
fontWeight: 'undefined',
fontSize: '',
fontSizeUnit: 'px',
fontFamily: '',
font: ''
});
const initSpread = (currSpread) => {
spread = currSpread;
let sheet = spread.getActiveSheet();
sheet.fromJSON(jsonData);
setStyles(sheet);
setSettings();
bindEvents();
}
const bindEvents = () => {
spread.bind(GC.Spread.Sheets.Events.SelectionChanged, () => {
setSettings();
});
}
const setSettings = () => {
let sheet = spread.getActiveSheet();
let state = { ...fontOption };
let activeCell = sheet.getCell(sheet.getActiveRowIndex(), sheet.getActiveColumnIndex());
state.font = activeCell.font();
state.fontStyle = fontStyleOrFontWeightSpreadValueToCssValue(activeCell.fontStyle());
state.fontWeight = fontStyleOrFontWeightSpreadValueToCssValue(activeCell.fontWeight());
let fontSize = activeCell.fontSize();
if (fontSize) {
let fontSizeDigit = parseFloat(fontSize);
let fontSizeUnit = fontSize.substring(('' + fontSizeDigit).length);
state.fontSize = '' + fontSizeDigit;
state.fontSizeUnit = fontSizeUnit;
} else {
state.fontSize = '';
state.fontSizeUnit = 'px';
}
state.fontFamily = activeCell.fontFamily() || '';
setFontOption(state);
}
const setFontByFont = () => {
let font = fontOption.font;
setFontToSelectedRanges(spread, (cell) => {
cell.font(font);
});
setSettings();
}
const setFontBySplittedFont = () => {
let fontStyle = fontOption.fontStyle,
fontWeight = fontOption.fontWeight,
fontFamily = fontOption.fontFamily,
fontSizeDigit = fontOption.fontSize,
fontSizeUnit = fontOption.fontSizeUnit, fontSize;
if (fontSizeDigit) {
fontSize = fontSizeDigit + (fontSizeUnit ? fontSizeUnit : 'px');
}
setFontToSelectedRanges(spread, (cell) => {
cell.fontStyle(fontStyleOrFontWeightCssValueToSpreadValue(fontStyle));
cell.fontWeight(fontStyleOrFontWeightCssValueToSpreadValue(fontWeight));
cell.fontSize(fontSize);
cell.fontFamily(fontFamily);
});
setSettings();
}
const setProperty = (e, property) => {
let value = e.target.value;
let arg = {};
arg[property] = value;
setFontOption({ ...fontOption, ...arg });
}
return (
<div className="sample-tutorial">
<div className="sample-spreadsheets">
<SpreadSheets workbookInitialized={initSpread} />
</div>
<div className="options-container">
<p>Select a cell, Set font for it.</p>
<div className="settings-row">
<label htmlFor="fontStyle">Font Style:</label>
<input type="text" onChange={(e) => { setProperty(e, 'fontStyle') }} id="fontStyle" value={fontOption.fontStyle} />
</div>
<div className="settings-row">
<label htmlFor="fontWeight">Font Weight:</label>
<input type="text" onChange={(e) => { setProperty(e, 'fontWeight') }} id="fontWeight" value={fontOption.fontWeight} />
</div>
<div className="settings-row">
<label htmlFor="fontSize">Font Size:</label>
<input id="fontSize" type="number" min="0" onChange={(e) => { setProperty(e, 'fontSize') }} value={fontOption.fontSize} />
<select id="fontSizeUnit" onChange={(e) => { setProperty(e, 'fontSizeUnit') }} value={fontOption.fontSizeUnit}>
<option value="px">px</option>
<option value="pt">pt</option>
</select>
</div>
<div className="settings-row">
<label htmlFor="fontFamily">Font Family:</label>
<input id="fontFamily" type="text" onChange={(e) => { setProperty(e, 'fontFamily') }} value={fontOption.fontFamily} />
</div>
<div className="settings-row">
<button id="set-splitted-font" className="settings-btn"
onClick={setFontBySplittedFont}>Set Font Using Font Properties
</button>
</div>
<br />
<div className="settings-row">
<label htmlFor="font">Font:</label>
<input type="text" id="font" onChange={(e) => { setProperty(e, 'font') }} value={fontOption.font} />
</div>
<div className="settings-row">
<button id="set-font" className="settings-btn" onClick={setFontByFont}>Set Font By Font
</button>
</div>
</div>
</div>
);
}
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import { SpreadSheets } from '@mescius/spread-sheets-react';
const Component = React.Component;
function fontStyleOrFontWeightCssValueToSpreadValue (value) {
// transfer css font style/weight to spread font style/weight
if (value === '') {
return undefined;
} else if (value === 'normal') {
return null;
} else {
return value;
}
}
function fontStyleOrFontWeightSpreadValueToCssValue (value) {
// transfer spread font style/weight to css font style/weight
if (value === undefined) {
return '';
} else if (value === null) {
return 'normal';
} else {
return value;
}
}
function setFontToSelectedRanges (spread, setFunc) {
let activeSheet = spread.getActiveSheet();
let selections = activeSheet.getSelections();
if (!selections) {
return;
}
activeSheet.suspendPaint();
for (let i = 0; i < selections.length; i++) {
let selection = selections[i];
if (!selection) {
return;
}
for (let r = 0; r < selection.rowCount; r++) {
for (let c = 0; c < selection.colCount; c++) {
let cell = activeSheet.getCell(r + selection.row, c + selection.col);
setFunc(cell);
}
}
}
activeSheet.resumePaint();
}
function setStyles (sheet) {
sheet.suspendPaint();
//Font
sheet.getCell(2, 0).font('italic normal 12px Mangal');
sheet.getCell(4, 0).font('normal bold 15px Arial Black');
sheet.getCell(6, 0).font('normal normal 18px Georgia');
//FontFamily
sheet.getCell(2, 1).fontFamily('Mangal');
sheet.getCell(4, 1).fontFamily('Arial Black');
sheet.getCell(6, 1).fontFamily('Georgia');
//FontSize
sheet.getCell(2, 2).fontSize('12px');
sheet.getCell(4, 2).fontSize('20px');
sheet.getCell(6, 2).fontSize('28px');
//Bold
sheet.getCell(2, 3).fontWeight('bold');
sheet.getCell(4, 3).fontWeight('normal');
//Italic
sheet.getCell(2, 4).fontStyle('italic');
sheet.getCell(4, 4).fontStyle('normal');
//Line
sheet.getCell(2, 5).textDecoration(GC.Spread.Sheets.TextDecorationType.underline);
sheet.getCell(4, 5).textDecoration(GC.Spread.Sheets.TextDecorationType.doubleUnderline);
sheet.getCell(6, 5).textDecoration(GC.Spread.Sheets.TextDecorationType.lineThrough);
sheet.getCell(8, 5).textDecoration(GC.Spread.Sheets.TextDecorationType.overline);
//Align
sheet.getCell(2, 6).vAlign(GC.Spread.Sheets.VerticalAlign.top).hAlign(GC.Spread.Sheets.HorizontalAlign.left);
sheet.getCell(4, 6).vAlign(GC.Spread.Sheets.VerticalAlign.center).hAlign(GC.Spread.Sheets.HorizontalAlign.center);
sheet.getCell(6, 6).vAlign(GC.Spread.Sheets.VerticalAlign.bottom).hAlign(GC.Spread.Sheets.HorizontalAlign.right);
//Forecolor
sheet.getCell(2, 7).foreColor('#F7A711');
sheet.getCell(4, 7).foreColor('#82BC00');
sheet.getCell(6, 7).foreColor('#C3C3C3');
//backgroundColor
sheet.getCell(2, 8).backColor('#F7A711');
sheet.getCell(4, 8).backColor('#82BC00');
sheet.getCell(6, 8).backColor('#C3C3C3');
//WordWrap
sheet.getCell(2, 9).wordWrap(true);
sheet.getCell(3, 9).wordWrap(true);
//Indent
sheet.getCell(2, 10).textIndent(1);
sheet.getCell(4, 10).textIndent(3);
sheet.getCell(6, 10).textIndent(-2);
//ShrinkToFit
sheet.getCell(2, 11).shrinkToFit(true).vAlign(GC.Spread.Sheets.VerticalAlign.center);
sheet.getCell(4, 11).shrinkToFit(true).vAlign(GC.Spread.Sheets.VerticalAlign.bottom);
sheet.resumePaint();
}
export class App extends Component {
constructor(props) {
super(props);
this.spread = null;
this.state = {
fontStyle: 'undefined',
fontWeight: 'undefined',
fontSize: '',
fontSizeUnit: 'px',
fontFamily: '',
font: ''
}
}
render() {
return (
<div className="sample-tutorial">
<div className="sample-spreadsheets">
<SpreadSheets workbookInitialized={ this.initSpread }/>
</div>
<div className="options-container">
<p>Select a cell, Set font for it.</p>
<div className="settings-row">
<label htmlFor="fontStyle">Font Style:</label>
<input type="text" onChange={(e) => { this.setProperty(e, 'fontStyle') }} id="fontStyle" value={ this.state.fontStyle }/>
</div>
<div className="settings-row">
<label htmlFor="fontWeight">Font Weight:</label>
<input type="text" onChange={(e) => { this.setProperty(e, 'fontWeight') }} id="fontWeight" value={ this.state.fontWeight }/>
</div>
<div className="settings-row">
<label htmlFor="fontSize">Font Size:</label>
<input id="fontSize" type="number" min="0" onChange={(e) => { this.setProperty(e, 'fontSize') }} value={ this.state.fontSize }/>
<select id="fontSizeUnit" onChange={(e) => { this.setProperty(e, 'fontSizeUnit') }} value={ this.state.fontSizeUnit }>
<option value="px">px</option>
<option value="pt">pt</option>
</select>
</div>
<div className="settings-row">
<label htmlFor="fontFamily">Font Family:</label>
<input id="fontFamily" type="text" onChange={(e) => { this.setProperty(e, 'fontFamily') }} value={ this.state.fontFamily }/>
</div>
<div className="settings-row">
<button id="set-splitted-font" className="settings-btn"
onClick={ this.setFontBySplittedFont }>Set Font Using Font Properties
</button>
</div>
<br/>
<div className="settings-row">
<label htmlFor="font">Font:</label>
<input type="text" id="font" onChange={(e) => { this.setProperty(e, 'font') }} value={ this.state.font }/>
</div>
<div className="settings-row">
<button id="set-font" className="settings-btn" onClick={ this.setFontByFont }>Set Font By Font
</button>
</div>
</div>
</div>
);
}
initSpread = (spread) => {
this.spread = spread;
let sheet = spread.getActiveSheet();
sheet.fromJSON(jsonData);
setStyles(sheet);
this.setSettings(spread);
this.bindEvents(spread);
}
bindEvents = (spread) => {
let self = this;
spread.bind(GC.Spread.Sheets.Events.SelectionChanged, function () {
self.setSettings(spread);
});
}
setSettings = (spread)=> {
let sheet = spread.getActiveSheet();
let state = this.state;
let activeCell = sheet.getCell(sheet.getActiveRowIndex(), sheet.getActiveColumnIndex());
state.font = activeCell.font();
state.fontStyle = fontStyleOrFontWeightSpreadValueToCssValue(activeCell.fontStyle());
state.fontWeight = fontStyleOrFontWeightSpreadValueToCssValue(activeCell.fontWeight());
let fontSize = activeCell.fontSize();
if (fontSize) {
let fontSizeDigit = parseFloat(fontSize);
let fontSizeUnit = fontSize.substring((''+ fontSizeDigit).length);
state.fontSize = '' + fontSizeDigit;
state.fontSizeUnit = fontSizeUnit;
} else {
state.fontSize = '';
state.fontSizeUnit = 'px';
}
state.fontFamily = activeCell.fontFamily() || '';
this.setState(state);
}
setFontByFont = () => {
let self = this, spread = self.spread, state = self.state;
let font = state.font;
setFontToSelectedRanges(spread, (cell) => {
cell.font(font);
});
self.setSettings(spread);
}
setFontBySplittedFont = () => {
let self = this, spread = self.spread, state = self.state;
let fontStyle = state.fontStyle,
fontWeight = state.fontWeight,
fontFamily = state.fontFamily,
fontSizeDigit = state.fontSize,
fontSizeUnit = state.fontSizeUnit, fontSize;
if (fontSizeDigit) {
fontSize = fontSizeDigit + (fontSizeUnit ? fontSizeUnit : 'px');
}
setFontToSelectedRanges(spread, (cell) => {
cell.fontStyle(fontStyleOrFontWeightCssValueToSpreadValue(fontStyle));
cell.fontWeight(fontStyleOrFontWeightCssValueToSpreadValue(fontWeight));
cell.fontSize(fontSize);
cell.fontFamily(fontFamily);
});
self.setSettings(spread);
}
setProperty(e, property) {
let value = e.target.value;
let arg = {};
arg[property] = value;
this.setState(arg);
}
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="data.js" type="text/javascript"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app" style="height: 100%;"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
label {
display: inline-block;
width: 80px;
}
.settings-row {
width: 100%;
height: 30px;
font-size: 13px;
}
.settings-btn {
display: inline-block;
width: 220px;
height: 21px;
}
#fontSize {
width: 80px;
}
.settings-row input {
width: 160px;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/cjs/react.production.js',
'react-dom': 'npm:react-dom/cjs/react-dom.production.js',
'react-dom/client': 'npm:react-dom/cjs/react-dom-client.production.js',
'scheduler': 'npm:scheduler/cjs/scheduler.production.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

You can customize the font style using code such as the following:
You can customize the font by splitted font properties using code such as the following:
You can also set text decorations, such as underline, doubleUnderline, lineThrough, and overline
You can set the font alignment like this:
You can set the font color and cell background color like this:
You can set the font format, such as wordwrap, indent, shrinkToFit, etc.
<template>
<div class="sample-tutorial">
<gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread">
</gc-spread-sheets>
<div class="options-container">
<p>Select a cell, Set font for it.</p>
<div class="settings-row">
<label for="fontStyle">Font Style:</label>
<input type="text" id="fontStyle" v-model="fontStyle" />
</div>
<div class="settings-row">
<label for="fontWeight">Font Weight:</label>
<input type="text" id="fontWeight" v-model="fontWeight" />
</div>
<div class="settings-row">
<label for="fontSize">Font Size:</label>
<input id="fontSize" type="number" min="0" v-model="fontSize" />
<select id="fontSizeUnit" v-model="fontSizeUnit">
<option value="px">px</option>
<option value="pt">pt</option>
</select>
</div>
<div class="settings-row">
<label for="fontFamily">Font Family:</label>
<input id="fontFamily" type="text" v-model="fontFamily" />
</div>
<div class="settings-row">
<button id="set-splitted-font" class="settings-btn" v-on:click="setFontBySplittedFont">Set Font Using Font
Properties</button>
</div>
<br />
<div class="settings-row">
<label for="font">Font:</label>
<input type="text" id="font" v-model="font" />
</div>
<div class="settings-row">
<button id="set-font" class="settings-btn" v-on:click="setFontByFont">Set Font By Font</button>
</div>
</div>
</div>
</template>
<script setup>
import '@mescius/spread-sheets-vue'
import "@mescius/spread-sheets-io";
import { ref, computed } from "vue";
import GC from "@mescius/spread-sheets";
const spread = ref(null);
const fontStyle = ref('');
const fontWeight = ref('');
const fontSize = ref('');
const fontSizeUnit = ref('px');
const fontFamily = ref('');
const font = ref('');
const fontStyleOrFontWeightCssValueToSpreadValue = (value) => {
if (value === '') {
return undefined;
} else if (value === 'normal') {
return null;
} else {
return value;
}
};
const fontStyleOrFontWeightSpreadValueToCssValue = (value) => {
if (value === undefined) {
return '';
} else if (value === null) {
return 'normal';
} else {
return value;
}
};
const setFontToSelectedRanges = (spread, setFunc) => {
let activeSheet = spread.getActiveSheet();
let selections = activeSheet.getSelections();
if (!selections) {
return;
}
activeSheet.suspendPaint();
for (let i = 0; i < selections.length; i++) {
let selection = selections[i];
if (!selection) {
return;
}
for (let r = 0; r < selection.rowCount; r++) {
for (let c = 0; c < selection.colCount; c++) {
let cell = activeSheet.getCell(r + selection.row, c + selection.col);
setFunc(cell);
}
}
}
activeSheet.resumePaint();
};
const setStyles = (sheet) => {
sheet.suspendPaint();
// Font
sheet.getCell(2, 0).font('italic normal 12px Mangal');
sheet.getCell(4, 0).font('normal bold 15px Arial Black');
sheet.getCell(6, 0).font('normal normal 18px Georgia');
// FontFamily
sheet.getCell(2, 1).fontFamily('Mangal');
sheet.getCell(4, 1).fontFamily('Arial Black');
sheet.getCell(6, 1).fontFamily('Georgia');
// FontSize
sheet.getCell(2, 2).fontSize('12px');
sheet.getCell(4, 2).fontSize('20px');
sheet.getCell(6, 2).fontSize('28px');
// Bold
sheet.getCell(2, 3).fontWeight('bold');
sheet.getCell(4, 3).fontWeight('normal');
// Italic
sheet.getCell(2, 4).fontStyle('italic');
sheet.getCell(4, 4).fontStyle('normal');
// Line
sheet.getCell(2, 5).textDecoration(GC.Spread.Sheets.TextDecorationType.underline);
sheet.getCell(4, 5).textDecoration(GC.Spread.Sheets.TextDecorationType.doubleUnderline);
sheet.getCell(6, 5).textDecoration(GC.Spread.Sheets.TextDecorationType.lineThrough);
sheet.getCell(8, 5).textDecoration(GC.Spread.Sheets.TextDecorationType.overline);
// Align
sheet.getCell(2, 6).vAlign(GC.Spread.Sheets.VerticalAlign.top).hAlign(GC.Spread.Sheets.HorizontalAlign.left);
sheet.getCell(4, 6).vAlign(GC.Spread.Sheets.VerticalAlign.center).hAlign(GC.Spread.Sheets.HorizontalAlign.center);
sheet.getCell(6, 6).vAlign(GC.Spread.Sheets.VerticalAlign.bottom).hAlign(GC.Spread.Sheets.HorizontalAlign.right);
// Forecolor
sheet.getCell(2, 7).foreColor('#F7A711');
sheet.getCell(4, 7).foreColor('#82BC00');
sheet.getCell(6, 7).foreColor('#C3C3C3');
// backgroundColor
sheet.getCell(2, 8).backColor('#F7A711');
sheet.getCell(4, 8).backColor('#82BC00');
sheet.getCell(6, 8).backColor('#C3C3C3');
// WordWrap
sheet.getCell(2, 9).wordWrap(true);
sheet.getCell(3, 9).wordWrap(true);
// Indent
sheet.getCell(2, 10).textIndent(1);
sheet.getCell(4, 10).textIndent(3);
sheet.getCell(6, 10).textIndent(-2);
// ShrinkToFit
sheet.getCell(2, 11).shrinkToFit(true).vAlign(GC.Spread.Sheets.VerticalAlign.center);
sheet.getCell(4, 11).shrinkToFit(true).vAlign(GC.Spread.Sheets.VerticalAlign.bottom);
sheet.resumePaint();
};
const initSpread = (spreadInstance) => {
spread.value = spreadInstance;
let sheet = spreadInstance.getActiveSheet();
sheet.fromJSON(jsonData);
setStyles(sheet);
setSettings(spreadInstance);
bindEvents(spreadInstance);
};
const bindEvents = (spreadInstance) => {
spreadInstance.bind(GC.Spread.Sheets.Events.SelectionChanged, () => {
setSettings(spreadInstance);
});
};
const setSettings = (spreadInstance) => {
let sheet = spreadInstance.getActiveSheet();
let activeCell = sheet.getCell(sheet.getActiveRowIndex(), sheet.getActiveColumnIndex());
font.value = activeCell.font();
fontStyle.value = fontStyleOrFontWeightSpreadValueToCssValue(activeCell.fontStyle());
fontWeight.value = fontStyleOrFontWeightSpreadValueToCssValue(activeCell.fontWeight());
let fontSizeValue = activeCell.fontSize();
if (fontSizeValue) {
let fontSizeDigit = parseFloat(fontSizeValue);
let fontSizeUnitValue = fontSizeValue.substring(('' + fontSizeDigit).length);
fontSize.value = '' + fontSizeDigit;
fontSizeUnit.value = fontSizeUnitValue;
} else {
fontSize.value = '';
fontSizeUnit.value = 'px';
}
fontFamily.value = activeCell.fontFamily() || '';
};
const setFontBySplittedFont = () => {
let fontStyleValue = fontStyle.value,
fontWeightValue = fontWeight.value,
fontFamilyValue = fontFamily.value,
fontSizeDigit = fontSize.value,
fontSizeUnitValue = fontSizeUnit.value, fontSizeValue;
if (fontSizeDigit) {
fontSizeValue = fontSizeDigit + (fontSizeUnitValue ? fontSizeUnitValue : 'px');
}
setFontToSelectedRanges(spread.value, (cell) => {
cell.fontStyle(fontStyleOrFontWeightCssValueToSpreadValue(fontStyleValue));
cell.fontWeight(fontStyleOrFontWeightCssValueToSpreadValue(fontWeightValue));
cell.fontSize(fontSizeValue);
cell.fontFamily(fontFamilyValue);
});
setSettings(spread.value);
};
const setFontByFont = () => {
let fontValue = font.value;
setFontToSelectedRanges(spread.value, (cell) => {
cell.font(fontValue);
});
setSettings(spread.value);
};
</script>
<style scoped>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
label {
display: inline-block;
width: 80px;
}
.settings-row {
width: 100%;
height: 30px;
font-size: 13px;
}
.settings-btn {
display: inline-block;
width: 220px;
height: 21px;
}
#fontSize {
width: 80px;
}
.settings-row input {
width: 160px;
}
</style>
<!DOCTYPE html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<title>SpreadJS VUE</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css"
href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="data.js"></script>
<script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script>
<script src="./systemjs.config.js"></script>
<script src="./compiler.js" type="module"></script>
<script>
var System = SystemJS;
System.import("./src/app.js");
System.import('$DEMOROOT$/en/lib/vue3/license.js');
</script>
</head>
<body>
<div id="app" style="height: 100%;"></div>
</body>
</html>
var jsonData = {
"name": "Sheet1",
"isSelected": true,
"activeRow": 10,
"activeCol": 5,
"visible": 1,
"theme": "Office",
"data": {
"dataTable": {
"1": {
"0": {
"value": "Font",
"style": {
"backColor": "#82bc00",
"foreColor": "white"
}
},
"1": {
"value": "FontFamily",
"style": {
"backColor": "#82bc00",
"foreColor": "white"
}
},
"2": {
"value": "FontSize",
"style": {
"backColor": "#82bc00",
"foreColor": "white"
}
},
"3": {
"value": "Bold",
"style": {
"backColor": "#82bc00",
"foreColor": "white"
}
},
"4": {
"value": "Italic",
"style": {
"backColor": "#82bc00",
"foreColor": "white"
}
},
"5": {
"value": "TextDecoration",
"style": {
"backColor": "#82bc00",
"foreColor": "white"
}
},
"6": {
"value": "Align",
"style": {
"backColor": "#82bc00",
"foreColor": "white"
}
},
"7": {
"value": "ForeColor",
"style": {
"backColor": "#82bc00",
"foreColor": "white"
}
},
"8": {
"value": "BackgroundColor",
"style": {
"backColor": "#82bc00",
"foreColor": "white"
}
},
"9": {
"value": "WordWrap",
"style": {
"backColor": "#82bc00",
"foreColor": "white"
}
},
"10": {
"value": "Indent",
"style": {
"backColor": "#82bc00",
"foreColor": "white"
}
},
"11": {
"value": "ShrinkToFit",
"style": {
"backColor": "#82bc00",
"foreColor": "white"
}
}
},
"2": {
"0": {
"value": "Font"
},
"1": {
"value": "FontFamily"
},
"2": {
"value": "FontSize"
},
"3": {
"value": "Bold"
},
"4": {
"value": "Italic"
},
"5": {
"value": "UnderLine"
},
"6": {
"value": "Align"
},
"7": {
"value": "Forecolor"
},
"8": {
"value": "BackColor"
},
"9": {
"value": "Word-Wrap Word-Wrap Word-Wrap"
},
"10": {
"value": "Indent"
},
"11": {
"value": "This is a long text"
}
},
"3": {
"9": {
"value": "Word\r\nWrap"
}
},
"4": {
"0": {
"value": "Font"
},
"1": {
"value": "FontFamily"
},
"2": {
"value": "FontSize"
},
"3": {
"value": "Bold"
},
"4": {
"value": "Italic"
},
"5": {
"value": "DbUnderLine"
},
"6": {
"value": "Align"
},
"7": {
"value": "Forecolor"
},
"8": {
"value": "BackColor"
},
"10": {
"value": "Indent"
},
"11": {
"value": "ShrinkToFit"
}
},
"6": {
"0": {
"value": "Font"
},
"1": {
"value": "FontFamily"
},
"2": {
"value": "FontSize"
},
"5": {
"value": "lineThrough"
},
"6": {
"value": "Align"
},
"7": {
"value": "Forecolor"
},
"8": {
"value": "BackColor"
},
"10": {
"value": "Indent"
}
},
"8": {
"5": {
"value": "overline"
}
}
},
"defaultDataNode": {
"style": {
"themeFont": "Body"
}
}
},
"rowHeaderData": {
"defaultDataNode": {
"style": {
"themeFont": "Body"
}
}
},
"colHeaderData": {
"defaultDataNode": {
"style": {
"themeFont": "Body"
}
}
},
"rows": [
null,
null,
{
"size": 50
},
{
"size": 50
},
{
"size": 50
},
null,
{
"size": 50
}
],
"columns": [
{
"size": 120
},
{
"size": 120
},
{
"size": 120
},
null,
null,
{
"size": 100
},
{
"size": 100
},
null,
{
"size": 120
},
{
"size": 80
},
{
"size": 80
},
{
"size": 100
}
],
"defaultData": {},
"leftCellIndex": 0,
"topCellIndex": 0,
"selections": {
"0": {
"row": 10,
"col": 5,
"rowCount": 1,
"colCount": 1
},
"length": 1
},
"rowOutlines": {
"items": []
},
"columnOutlines": {
"items": []
},
"cellStates": {},
"states": {},
"outlineColumnOptions": {},
"autoMergeRangeInfos": [],
"shapeCollectionOption": {
"snapMode": 0
},
"printInfo": {
"paperSize": {
"width": 850,
"height": 1100,
"kind": 1
}
}
}
(function (global) {
SystemJS.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
packageConfigPaths: [
'./node_modules/*/package.json',
"./node_modules/@mescius/*/package.json",
"./node_modules/@babel/*/package.json",
"./node_modules/@vue/*/package.json"
],
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-io': 'npm:@mescius/spread-sheets-io/index.js',
'@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js',
'vue': "npm:vue/dist/vue.esm-browser.js",
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
"systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js",
},
meta: {
'*.css': { loader: 'systemjs-plugin-css' },
'*.vue': { loader: "../plugin-vue/index.js" }
}
});
})(this);

You can customize the font style using code such as the following:
You can customize the font by splitted font properties using code such as the following:
You can also set text decorations, such as underline, doubleUnderline, lineThrough, and overline
You can set the font alignment like this:
You can set the font color and cell background color like this:
You can set the font format, such as wordwrap, indent, shrinkToFit, etc.
// @ts-ignore
import { Component, NgModule, enableProdMode } from '@angular/core';
// @ts-ignore
import { BrowserModule } from '@angular/platform-browser';
// @ts-ignore
import { FormsModule } from '@angular/forms';
// @ts-ignore
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
// @ts-ignore
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import GC from '@mescius/spread-sheets';
import './styles.css';
function fontStyleOrFontWeightCssValueToSpreadValue (value) {
// transfer css font style/weight to spread font style/weight
if (value === '') {
return undefined;
} else if (value === 'normal') {
return null;
} else {
return value;
}
}
function fontStyleOrFontWeightSpreadValueToCssValue (value) {
// transfer spread font style/weight to css font style/weight
if (value === undefined) {
return '';
} else if (value === null) {
return 'normal';
} else {
return value;
}
}
function setFontToSelectedRanges (spread, setFunc) {
let activeSheet = spread.getActiveSheet();
let selections = activeSheet.getSelections();
if (!selections) {
return;
}
activeSheet.suspendPaint();
for (let i = 0; i < selections.length; i++) {
let selection = selections[i];
if (!selection) {
return;
}
for (let r = 0; r < selection.rowCount; r++) {
for (let c = 0; c < selection.colCount; c++) {
let cell = activeSheet.getCell(r + selection.row, c + selection.col);
setFunc(cell);
}
}
}
activeSheet.resumePaint();
}
function setStyles (sheet) {
sheet.suspendPaint();
//Font
sheet.getCell(2, 0).font('italic normal 12px Mangal');
sheet.getCell(4, 0).font('normal bold 15px Arial Black');
sheet.getCell(6, 0).font('normal normal 18px Georgia');
//FontFamily
sheet.getCell(2, 1).fontFamily('Mangal');
sheet.getCell(4, 1).fontFamily('Arial Black');
sheet.getCell(6, 1).fontFamily('Georgia');
//FontSize
sheet.getCell(2, 2).fontSize('12px');
sheet.getCell(4, 2).fontSize('20px');
sheet.getCell(6, 2).fontSize('28px');
//Bold
sheet.getCell(2, 3).fontWeight('bold');
sheet.getCell(4, 3).fontWeight('normal');
//Italic
sheet.getCell(2, 4).fontStyle('italic');
sheet.getCell(4, 4).fontStyle('normal');
//Line
sheet.getCell(2, 5).textDecoration(GC.Spread.Sheets.TextDecorationType.underline);
sheet.getCell(4, 5).textDecoration(GC.Spread.Sheets.TextDecorationType.doubleUnderline);
sheet.getCell(6, 5).textDecoration(GC.Spread.Sheets.TextDecorationType.lineThrough);
sheet.getCell(8, 5).textDecoration(GC.Spread.Sheets.TextDecorationType.overline);
//Align
sheet.getCell(2, 6).vAlign(GC.Spread.Sheets.VerticalAlign.top).hAlign(GC.Spread.Sheets.HorizontalAlign.left);
sheet.getCell(4, 6).vAlign(GC.Spread.Sheets.VerticalAlign.center).hAlign(GC.Spread.Sheets.HorizontalAlign.center);
sheet.getCell(6, 6).vAlign(GC.Spread.Sheets.VerticalAlign.bottom).hAlign(GC.Spread.Sheets.HorizontalAlign.right);
//Forecolor
sheet.getCell(2, 7).foreColor('#F7A711');
sheet.getCell(4, 7).foreColor('#82BC00');
sheet.getCell(6, 7).foreColor('#C3C3C3');
//backgroundColor
sheet.getCell(2, 8).backColor('#F7A711');
sheet.getCell(4, 8).backColor('#82BC00');
sheet.getCell(6, 8).backColor('#C3C3C3');
//WordWrap
sheet.getCell(2, 9).wordWrap(true);
sheet.getCell(3, 9).wordWrap(true);
//Indent
sheet.getCell(2, 10).textIndent(1);
sheet.getCell(4, 10).textIndent(3);
sheet.getCell(6, 10).textIndent(-2);
//ShrinkToFit
sheet.getCell(2, 11).shrinkToFit(true).vAlign(GC.Spread.Sheets.VerticalAlign.center);
sheet.getCell(4, 11).shrinkToFit(true).vAlign(GC.Spread.Sheets.VerticalAlign.bottom);
sheet.resumePaint();
}
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
spread: GC.Spread.Sheets.Workbook;
fontStyle = 'undefined';
fontWeight = 'undefined';
fontSize = '';
fontSizeUnit = 'px';
fontFamily = '';
font = '';
hostStyle = {
width: 'calc(100% - 280px)',
height: '100%',
overflow: 'hidden',
float: 'left'
};
initSpread($event: any) {
let spread = this.spread = $event.spread;
let sheet = this.spread.getActiveSheet();
sheet.fromJSON(jsonData);
setStyles(sheet);
this.setSettings(spread);
this.bindEvents(spread);
}
bindEvents (spread: GC.Spread.Sheets.Workbook) {
let self = this;
spread.bind(GC.Spread.Sheets.Events.SelectionChanged, function () {
self.setSettings(spread);
});
}
setSettings (spread: GC.Spread.Sheets.Workbook) {
let sheet = spread.getActiveSheet();
let activeCell = sheet.getCell(sheet.getActiveRowIndex(), sheet.getActiveColumnIndex());
this.font = activeCell.font();
this.fontStyle = fontStyleOrFontWeightSpreadValueToCssValue(activeCell.fontStyle());
this.fontWeight = fontStyleOrFontWeightSpreadValueToCssValue(activeCell.fontWeight());
let fontSize = activeCell.fontSize();
if (fontSize) {
let fontSizeDigit = parseFloat(fontSize);
let fontSizeUnit = fontSize.substring((''+ fontSizeDigit).length);
this.fontSize = '' + fontSizeDigit;
this.fontSizeUnit = fontSizeUnit;
} else {
this.fontSize = '';
this.fontSizeUnit = 'px';
}
this.fontFamily = activeCell.fontFamily() || '';
}
setFontBySplittedFont () {
let self = this, spread = self.spread;
let fontStyle = self.fontStyle,
fontWeight = self.fontWeight,
fontFamily = self.fontFamily,
fontSizeDigit = self.fontSize,
fontSizeUnit = self.fontSizeUnit, fontSize;
if (fontSizeDigit) {
fontSize = fontSizeDigit + (fontSizeUnit ? fontSizeUnit : 'px');
}
setFontToSelectedRanges(spread, (cell) => {
cell.fontStyle(fontStyleOrFontWeightCssValueToSpreadValue(fontStyle));
cell.fontWeight(fontStyleOrFontWeightCssValueToSpreadValue(fontWeight));
cell.fontSize(fontSize);
cell.fontFamily(fontFamily);
});
self.setSettings(spread);
}
setFontByFont () {
let self = this, spread = self.spread;
let font = self.font;
setFontToSelectedRanges(spread, (cell) => {
cell.font(font);
});
self.setSettings(spread);
}
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule, FormsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule {}
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/core-js/client/shim.min.js"></script>
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="data.js" type="text/javascript"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)">
</gc-spread-sheets>
<div class="options-container">
<p>Select a cell, Set font for it.</p>
<div class="settings-row">
<label for="fontStyle">Font Style:</label>
<input id="fontStyle" type="text" [(ngModel)]="fontStyle"/>
</div>
<div class="settings-row">
<label for="fontWeight">Font Weight:</label>
<input id="fontWeight" type="text" [(ngModel)]="fontWeight"/>
</div>
<div class="settings-row">
<label for="fontSize">Font Size:</label>
<input id="fontSize" type="number" min="0" [(ngModel)]="fontSize"/>
<select id="fontSizeUnit" [(ngModel)]="fontSizeUnit">
<option value="px">px</option>
<option value="pt">pt</option>
</select>
</div>
<div class="settings-row">
<label for="fontFamily">Font Family:</label>
<input id="fontFamily" type="text" [(ngModel)]="fontFamily"/>
</div>
<div class="settings-row">
<button id="set-splitted-font" class="settings-btn" (click)="setFontBySplittedFont()">Set Font Using Font Properties</button>
</div>
<br/>
<div class="settings-row">
<label for="font">Font:</label>
<input type="text" id="font" [(ngModel)]="font"/>
</div>
<div class="settings-row">
<button id="set-font" class="settings-btn" (click)="setFontByFont()">Set Font By Font</button>
</div>
</div>
</div>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
label {
display: inline-block;
width: 80px;
}
.settings-row {
width: 100%;
height: 30px;
font-size: 13px;
}
.settings-btn {
display: inline-block;
width: 220px;
height: 21px;
}
#fontSize {
width: 80px;
}
.settings-row input {
width: 160px;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'core-js': 'npm:core-js/client/shim.min.js',
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-angular': 'npm:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);